const Mesa = require('vendor/Mesa.js');
const ShopifyGraphql = require('vendor/ShopifyGraphql.js');
const Shopify= require('vendor/Shopify.js');

/**
 * A Mesa Script exports a class with a script() method.
 */
module.exports = new class {
  script = (payload, context) => {
    let vars = context.steps;
    
    let query = `
      query publications {
        publications(first: 250) {
          nodes {
            id
            name
          }
        }
      }
    `;

    const r = ShopifyGraphql.send(query);
    let publications = r.data.publications.nodes;

    Mesa.trigger.setTaskExternalData({
      "label": "Channels: " + publications.map(obj => obj.name).join(', '),
    })

    Mesa.output.next({"publications": r.data.publications.nodes});
  }
}
