const Mesa = require('vendor/Mesa.js');
const ShopifyGraphql = require('vendor/ShopifyGraphql.js');
const Shopify= require('vendor/Shopify.js');

/**
 * A Mesa Script exports a class with a script() method.
 */
module.exports = new class {
  script = (payload, context) => {
    let vars = context.steps;
    
    let lines = [];
    for (let publication of vars.custom.publications) {
      let name = publication.name.replace(/ /g, "");
      let line = `published${name}: publishedOnPublication(publicationId: "${publication.id}")`;
      lines.push(line);
    } 

    Mesa.log.info("lines", lines);

    let query = `
      query isProductPublishedToPublication($id:ID!) {
        product(id:$id){
          ${lines.join("\n")}
        }
      }
    `;


    const r = ShopifyGraphql.send(query, {
      "id": "gid://shopify/Product/" + vars.shopify.id,
    });

    Mesa.trigger.setTaskExternalData({
      "label": Object.entries(r.data.product).map(([key, value]) => `${key}: ${value}`).join(', '),
    })

    Mesa.output.next({"product": r.data.product});
  }
}
